<?
/*
(C) 2004-2013 DatuX - info@datux.nl

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

	$LEVEL=5;
	include_once("../common.php");
	require_once("openswan.php");
	include_once("../form.php");
?>

<?
	$name=$_REQUEST[name];

	Title(_VPNtunnelSettings($name));

	//default settings
	$new_pfs="on";
	$new_ikev2="off";
	$new_leftsourceip=GetFirstLanIp();

	//read current configuration
	if ($name)
	{
		$new_name=$name;
		$tunnel=vpn_ReadTunnel($name);
		$new_leftsubnet=$tunnel[leftsubnet];
		$new_leftid=$tunnel[leftid];
		$new_rightsubnet=$tunnel[rightsubnet];
		$new_leftsourceip=$tunnel[leftsourceip];
		$new_authby=$tunnel[authby];
		$new_right=$tunnel[right];
		$new_rightrsasigkey=vpn_PubToReadable($tunnel[rightrsasigkey]);
		$new_secret=vpn_ReadSecret($name);
		if ($tunnel[compress]=='yes')
			$new_compress="on";
		else
			$new_compress="off";

		if ($tunnel[pfs]=='yes')
			$new_pfs="on";
		else
		 	$new_pfs="off";

		if ($tunnel[ikev2]=='insist')
			$new_ikev2="on";
		else
		 	$new_ikev2="off";


		if ($_REQUEST[del])
		{
			vpn_DelTunnel($name);
			Redirect("listtunnels.php");
		}
	}

	//overwrite configration with posted values
	OverwriteNewVars();

	//verify configuration
	if (!vpn_ValidName($new_name))
		$errors[new_name]=_EnterValidName();
	elseif (!ValidIp($new_leftid) && !ValidHostname($new_leftid))
		$errors[new_leftid]=_EnterValidIp();
	elseif (!ValidSubnet($new_leftsubnet))
		$errors[new_leftsubnet]=_EnterValidSubnet();
	elseif (!ValidIp($new_right) && !ValidHostname($new_right))
		$errors[new_right]=_EnterValidIp();
	elseif (!ValidSubnet($new_rightsubnet))
		$errors[new_rightsubnet]=_EnterValidSubnet();
	elseif (
		!$new_authby
	)
		$errors[new_authby]=_SelectAuthMethod();
	elseif (
		($new_authby=='rsasig')
		&& $new_rightrsasigkey
		&& !vpn_ValidPubKey($new_rightrsasigkey)
	)
		$errors[new_rightrsasigkey]=_EnterValidKey();
	elseif (
		($new_authby=='rsasig')
		&& $new_rightrsasigkey
		&& (vpn_SameKey(vpn_ReadPubKey(),$new_rightrsasigkey))
	)
		$errors[new_rightrsasigkey]=_ErrorThisIsOurKey();
	elseif (
		($new_authby=='secret')
		&& !vpn_ValidSecret($new_secret)
	)
		$errors[new_secret]=_EnterValidPassword();
	elseif ($new_leftsourceip && !ValidIp($new_leftsourceip))
		$errors[new_leftsourceip]=_EnterValidIp();
	else {
		$tunnels=vpn_ReadTunnels();
		foreach ($tunnels as $name=>$data)
		{
			if (($name != $new_name) && ($data[leftid]==$new_leftid) && ($data[right]==$new_right))
			{
				$errors[new_leftid]=_TunnelAlreadyExistsBetweenHosts($name);
				break;
			}
		}
	}




	//safe configuration?
	if (!$errors && ($_REQUEST[save] || $_REQUEST[autoconf] || $_REQUEST[puburi]))
	{
		$tunnel[leftsubnet]=$new_leftsubnet;
		$tunnel[leftid]=$new_leftid;
		//FIXME:shouldnt use %defaultroute anymore, this doesnt work with multihomed hosts...
		$tunnel[left]='%defaultroute';
		//...but this doenst work on natted hosts:
		//$tunnel[left]=$new_leftid;
		$tunnel[rightsubnet]=$new_rightsubnet;
		$tunnel[right]=$new_right;

		$rightrsasigkey=vpn_ReadableToPub($new_rightrsasigkey);
		if ($rightrsasigkey)
		{
			$tunnel[rightrsasigkey]=$rightrsasigkey;
		}
		else
		{
			unset($tunnel[rightrsasigkey]);
		}

		if ($new_compress=="on")
			$tunnel[compress]='yes';
		else
			$tunnel[compress]='no';

		$tunnel[authby]=$new_authby;
		//default settings
		$tunnel[auto]="ignore";

		if ($new_pfs=='on')
			$tunnel[pfs]="yes";
		else
			$tunnel[pfs]="no";

		if ($new_ikev2=='on')
			$tunnel[ikev2]="insist";
		else
			$tunnel[ikev2]="never";

		if ($new_leftsourceip)
			$tunnel[leftsourceip]=$new_leftsourceip;
		else
			unset($tunnel[leftsourceip]);

		vpn_WriteTunnel($new_name,$tunnel);
		vpn_WriteSecret($new_name,$new_secret);

		//test settings and return to overview
		if ($_REQUEST[save])
			Redirect("testtunnel.php?name=$new_name&mode=up&dsturi=listtunnels.php");
		//go to auto configurator
		elseif ($_REQUEST[autoconf])
			Redirect("autoconf.php?name=$new_name");
		//kopieer de publieke key naar puburi, voor auto config
		elseif ($_REQUEST[puburi])
		{
			//doel adress waar de publieke key heen moet
			$dsturi="$_REQUEST[puburi]&new_rightrsasigkey=".urlencode(vpn_ReadPubKey());
			//we gaan naar het doel, maar VIA testtunnel omdat de tunnel eerst
			//getest moet worden op conflicten.
			Redirect("testtunnel.php?name=$new_name&mode=up&dsturi=".urlencode($dsturi));
		}

	}


?>

<? Head($errors); ?>


<? FormStart($TITLE) ?>

<table>
	<tr>
		<td><?=_Name()?></td>
		<TD><? InputText("new_name",$errors,'',!$name); ?></td>
	</tr>
</table>


<table width=100%>
	<tr>
		<td>
			<h2><?=_ThisSide()?></h2>

			<table>
				<tr>
					<td><?=_LocalAddress()?></td>
					<td><? InputText("new_leftid",$errors); ?></td>
				</tr>
				<tr>
					<td><?=_LocalNet()?></td>
					<TD><? InputText("new_leftsubnet",$errors); ?></td>
				</tr>
			</table>
		</td>
		<td>
			<h2><?=_RemoteSide()?></h2>

			<table>
				<tr>
					<td><?=_RemoteAddress()?></td>
					<TD><? InputText("new_right",$errors); ?></td>
				</tr>
				<tr>
					<td><?=_RemoteNet()?></td>
					<td><? InputText("new_rightsubnet",$errors); ?></td>
				</tr>
			</table>
		</td>
	</tr>
</table>

<hr>

<!--
<p>
<?=_Compression()?>
:
<?InputCheckBox("new_compress",$errors);?>
-->

<p>
Perfect Forward Secrecy:
<?InputCheckBox("new_pfs",$errors);?>

<p>
IKE v2:
<?InputCheckBox("new_ikev2",$errors);?>


<p>
Source IP:
<?InputText("new_leftsourceip",$errors);?>

<p>
<table>
	<tr>
		<td>
		<?=_AuthenticationMode();?>
		<?
			Select( "new_authby",array(
				'secret'=>_SharedSecret(),
				'rsasig'=>_RSAsig(),
			),$errors,'',1,1 );
		?>
		</td>
	</tr>
	<tr>
		<td>
		<?
		if ($new_authby=='rsasig')
		{
			echo _PublicKeyRemoteServer();
			echo "<br>";
			TextArea("new_rightrsasigkey",$errors,'',5,55);
		}
		elseif ($new_authby=='secret')
		{
			echo _Secret().":";
			InputText("new_secret",$errors);
		}
		?>
		</td>
	</tr>
</table>

<p>
<? Button("save",_Save()); ?>
<? Button("autoconf",_AutoConfigure()); ?>

<? FormEnd() ?>

<?	Foot();	 ?>
