<?
/*
(C) 2004-2013 DatuX - info@datux.nl

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


    $LEVEL=10;
    require_once("../common.php");
    require_once("../form.php");
    require_once("openswan.php");
    require_once("../monitoring/state.php");

?>

<? OverwriteNewVars(); ?>

<? Title(_VPNTunnels()); ?>

<? Head($errors,'',60); ?>

<h1><?=$TITLE?></h1>


<table class="list">
    <th></th>
    <th><?=_Name()?></th>
    <th><?=_LocalNet()?></th>
    <th><?=_LocalAddress()?></th>
    <th><?=_Status()?></th>
    <th><?=_RemoteAddress()?></th>
    <th><?=_RemoteNet()?></th>
    <th>&nbsp;</th>
    <th></th>

    <?
    $tunnels=vpn_ReadTunnels();
    $status=vpn_GetStatus();

    //  echo "<pre>TEST ";print_r($status);

    $untested=0;
    foreach ($tunnels as $name=>$data)
    {
        echo "<tr ";
        // if (!$status[$name][state])
        if ($data["auto"]!="up")
            echo "style='text-decoration:line-through'";
        echo ">";

        echo "<td>";
        if ($data["auto"]=="up")
        {
            //status NOT ok?
            if ($status[$name][phase1] != "OK" || $status[$name][phase2] != "OK")
                LinkDefault("testtunnel.php?name=$name&mode=down", _Started(), "<img src='../img/CAUTION.gif'>",_ConfirmDisable($name));
            else
                LinkDefault("testtunnel.php?name=$name&mode=down", _Started(), "<img src='../img/start.gif'>",_ConfirmDisable($name));
        }
        else
            LinkIcon_Start("testtunnel.php?name=$name&mode=up");


        echo "<td><a href='edittunnel.php?name=$name'>";
        echo $name."</a>";


        echo "<td>";
        echo $data[leftsubnet];

        echo "<td>";
        echo $data[leftid];

        echo "<td>";


        //should be up?
        if ($data["auto"]=="up")
        {
            $statehtml=State_GetHtml("ipsec_$name",true);
            echo "<a href='editvpnmon.php?tunnelName=$name'>";
            if ($statehtml)
                echo $statehtml;
            else
                echo "<img title='"._vpnMon()."' src='../img/mon.gif'>";
            echo "</a>";

            echo "<a href='tunnelstatus.php?name=$name'> ";

            if ($status[$name][phase1]!="OK")
                echo "Phase 1: ".$status[$name][phase1];
            elseif ($status[$name][phase2]!="OK")
                echo "Phase 2: ".$status[$name][phase2];
            else
                echo "OK";

            echo "</a>";
        }

        if (!vpn_TunnelIsTested($name))
        {
            echo " <img src='../img/WARNING.gif'>";
            echo _TunnelUntested();
            $untested=1;
        }

        echo "<td>";
        echo $data[right];

        echo "<td>";
        echo $data[rightsubnet];



        echo "<td>";
        LinkIcon_Del("edittunnel.php?name=$name".urlencode($line)."&del=1",_ConfirmDeleteTunnel()." ".$name);

        echo "<td>";
        Comment($name);

        echo "</tr>";
    }

    if (!$tunnels)
        echo "<tr colspan=5><td>"._NoTunnelsDefined()."</tr>";
    ?>

</table>

<?

if ($untested)
{
    echo "<p class='error'>";
    echo "<img src='../img/WARNING.gif'>";
    echo _ConfigNotTestedWarning();
    echo "</p>";
}
?>

<?
echo "<p>";
LinkButton(_Add(),"edittunnel.php");
echo "<br>";
LinkButton(_Restart(),"testtunnel.php?restart=1");
?>

<p>
<?=_PublicKeyOfThisServer()?>
<br>
<table border=1><TR><TD style='font-size:70%'>
    <?= preg_replace("/(.{50})/",'$0<br>',vpn_ReadPubKey());?>
</TD></TR>
</table>

<?    Foot();     ?>
